local bg = love.graphics.newImage('mountain-and-lake-landscape-800x600.jpg')
local fg = love.graphics.newImage('image1.jpg')
local mask = love.graphics.newImage('Circle.png')
local canvas = love.graphics.newCanvas()

local x, y
local a = 0

-- In the Circle.png image, the circle is at 570, 370 with a size of 460x460.
function love.update(dt)
  a = a + dt
  x = (math.sin(a * 1.5) + 1) / 2 * (love.graphics.getWidth() - 460) - 570
  y = (math.sin(a * 2) + 1) / 2 * (love.graphics.getHeight() - 460) - 370
end

function love.draw()
  love.graphics.setCanvas(canvas)
  love.graphics.setBlendMode('replace', 'premultiplied')
  love.graphics.draw(fg)
  love.graphics.setBlendMode('multiply', 'premultiplied')
  love.graphics.draw(mask, x, y)
  love.graphics.setCanvas()

  love.graphics.setBlendMode('replace', 'premultiplied')
  love.graphics.draw(bg)
  love.graphics.setBlendMode('alpha', 'alphamultiply')
  love.graphics.draw(canvas)
end

function love.keypressed(k)
  return k == "escape" and love.event.quit()
end
